using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace DataConcurrencyDemos
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.TextBox TextBox1;
		protected System.Web.UI.WebControls.TextBox TextBox2;
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.Button Button2;
		protected System.Web.UI.WebControls.Button Button3;
		protected System.Web.UI.WebControls.Button Button4;
		protected System.Web.UI.WebControls.Button Button5;
		protected System.Web.UI.WebControls.Label lblMsg;
		protected System.Web.UI.WebControls.Button Button1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!Page.IsPostBack)
			{
				BindGrid();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Button5.Click += new System.EventHandler(this.Button5_Click);
			this.Button4.Click += new System.EventHandler(this.Button4_Click);
			this.Button3.Click += new System.EventHandler(this.Button3_Click);
			this.Button2.Click += new System.EventHandler(this.Button2_Click);
			this.Button1.Click += new System.EventHandler(this.Button1_Click);
			this.DataGrid1.SelectedIndexChanged += new System.EventHandler(this.DataGrid1_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void DataGrid1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			TextBox1.Text=DataGrid1.SelectedItem.Cells[0].Text;
			TextBox2.Text=DataGrid1.SelectedItem.Cells[1].Text;
		}

		private void BindGrid()
		{
			DataSet ds=new DataSet();
			if(Session["myds"]==null)
			{
				SqlDataAdapter da=new SqlDataAdapter("select * from employees",@"data source=.\vsdotnet;initial catalog=northwind;user id=sa");
				da.Fill(ds,"myemployees");
				DataColumn[] pk=new DataColumn[1];
				pk[0]=ds.Tables[0].Columns["employeeid"];
				ds.Tables[0].PrimaryKey=pk;
				Session["myds"]=ds;
			}
			else
			{
				ds=(DataSet)Session["myds"];
			}
			DataGrid1.DataSource=ds;
			DataGrid1.DataKeyField="employeeid";
			DataGrid1.DataBind();

		}

		private void Button1_Click(object sender, System.EventArgs e)
		{
			int employeeid;
			employeeid=(int)DataGrid1.DataKeys[DataGrid1.SelectedIndex];

			DataSet ds=(DataSet)Session["myds"];
			DataRow[] rows=ds.Tables[0].Select("employeeid=" + employeeid);
			rows[0]["firstname"]=TextBox1.Text;
			rows[0]["lastname"]=TextBox2.Text;

			BindGrid();

		}

		private void Button2_Click(object sender, System.EventArgs e)
		{
			SqlDataAdapter da=new SqlDataAdapter();

			SqlConnection cnn=new SqlConnection(@"data source=.\vsdotnet;initial catalog=northwind;user id=sa");
			SqlCommand cmd=new SqlCommand();
			cmd.Connection=cnn;
			cmd.CommandText="update employees set firstname=@firstname, lastname=@lastname where employeeid=@empid";

			SqlParameter p1=new SqlParameter("@firstname",SqlDbType.VarChar);
			p1.SourceColumn="firstname";
			SqlParameter p2=new SqlParameter("@lastname",SqlDbType.VarChar);
			p2.SourceColumn="lastname";
			SqlParameter p3=new SqlParameter("@empid",SqlDbType.Int);
			p3.SourceColumn="employeeid";

			cmd.Parameters.Add(p1);
			cmd.Parameters.Add(p2);
			cmd.Parameters.Add(p3);

			da.UpdateCommand=cmd;

			DataSet ds=(DataSet)Session["myds"];
			try
			{
				da.Update(ds,"myemployees");
			}
			catch(Exception ex)
			{
				lblMsg.Text=ex.Message;
			}
		}

		private void Button3_Click(object sender, System.EventArgs e)
		{
			SqlDataAdapter da=new SqlDataAdapter();

			SqlConnection cnn=new SqlConnection(@"data source=.\vsdotnet;initial catalog=northwind;user id=sa");
			SqlCommand cmd=new SqlCommand();
			cmd.Connection=cnn;
			cmd.CommandText="update employees set firstname=@firstname, lastname=@lastname where employeeid=@empid and firstname=@oldfirstname and lastname=@oldlastname";

			SqlParameter p1=new SqlParameter("@firstname",SqlDbType.VarChar);
			p1.SourceColumn="firstname";
			SqlParameter p2=new SqlParameter("@lastname",SqlDbType.VarChar);
			p2.SourceColumn="lastname";
			SqlParameter p3=new SqlParameter("@empid",SqlDbType.Int);
			p3.SourceColumn="employeeid";
			SqlParameter p4=new SqlParameter("@oldfirstname",SqlDbType.VarChar);
			p4.SourceColumn="firstname";
			p4.SourceVersion=DataRowVersion.Original;
			SqlParameter p5=new SqlParameter("@oldlastname",SqlDbType.VarChar);
			p5.SourceColumn="lastname";
			p4.SourceVersion=DataRowVersion.Original;

			cmd.Parameters.Add(p1);
			cmd.Parameters.Add(p2);
			cmd.Parameters.Add(p3);
			cmd.Parameters.Add(p4);
			cmd.Parameters.Add(p5);

			da.UpdateCommand=cmd;

			DataSet ds=(DataSet)Session["myds"];
			try
			{
				da.Update(ds,"myemployees");
			}
			catch(Exception ex)
			{
				lblMsg.Text=ex.Message;
			}


		}

		private void Button4_Click(object sender, System.EventArgs e)
		{
			SqlDataAdapter da=new SqlDataAdapter();

			SqlConnection cnn=new SqlConnection(@"data source=.\vsdotnet;initial catalog=northwind;user id=sa");
			SqlCommand cmd=new SqlCommand();
			cmd.Connection=cnn;
			cmd.CommandText="update employees set firstname=@firstname, lastname=@lastname where employeeid=@empid and TSID=@tsid";

			SqlParameter p1=new SqlParameter("@firstname",SqlDbType.VarChar);
			p1.SourceColumn="firstname";
			SqlParameter p2=new SqlParameter("@lastname",SqlDbType.VarChar);
			p2.SourceColumn="lastname";
			SqlParameter p3=new SqlParameter("@empid",SqlDbType.Int);
			p3.SourceColumn="employeeid";
			SqlParameter p4=new SqlParameter("@tsid",SqlDbType.Timestamp);
			p4.SourceColumn="tsid";
			p4.SourceVersion=DataRowVersion.Original;

			cmd.Parameters.Add(p1);
			cmd.Parameters.Add(p2);
			cmd.Parameters.Add(p3);
			cmd.Parameters.Add(p4);

			da.UpdateCommand=cmd;

			DataSet ds=(DataSet)Session["myds"];
			try
			{
				da.Update(ds,"myemployees");
			}
			catch(Exception ex)
			{
				lblMsg.Text=ex.Message;
			}

		}

		private void Button5_Click(object sender, System.EventArgs e)
		{
			SqlDataAdapter da=new SqlDataAdapter("select * from employees",@"data source=.\vsdotnet;initial catalog=northwind;user id=sa");
			SqlCommandBuilder cb=new SqlCommandBuilder(da);
			DataSet ds=(DataSet)Session["myds"];
			try
			{
				da.Update(ds,"myemployees");
			}
			catch(Exception ex)
			{
				lblMsg.Text=ex.Message;
			}
		}
	}
}
